#ifndef Karte_H
#define Karte_H

#include <Datei.h>
#include <Vec2.h>
#include <UIInitialization.h>
#include "../Team/Team.h"
#include "../Spieler/Spieler.h"
#include "../Objekt/SpielObjekt.h"
#include "KSGNetwork.h"
#include "Strukturen.h"

using namespace Framework;

class Karte : public virtual ReferenceCounter
{
private:
    Vec2< int > gre;
    int spielerAnzahl;
    int teamAnzahl;
    Array< int > *spielerFarbe;
    Array< int > *teamFarbe;
    RCArray< Text > *teamName;
    Array< int > *teamGre;
    RCArray< RessourceStr > *ressources;
    RCArray< ObjektStr > *objekte;
    RCArray< SpielerStr > *spieler;
    RCArray< TeamStr > *teams;

public:
    // Konstruktor
    Karte();
    // Destruktor
    ~Karte();
    // nicht constant
    void ladeSts( Datei *zDatei ); // call 1
    void ladeMap( Datei *zDatei, int mapId, KSGClient::SpielServerClient *zSpielKlient, Text *zGamePath ); // call 2
    // constant
    Vec2< int > getSize() const;
    Spieler *createSpieler( int sNum, UIInit &uiFactory, KSGClient::InformationServerClient *zInfoK, Animation2DData *zFStart, Animation2DData *zFBurn ) const;
    Team *createTeam( int tNum ) const;
    SpielObjekt *createObjekt( int oNum, UIInit &uiFactory ) const;
    Iterator< ObjektStr * > getObjekte() const;
    int getMaxTeamAnzahl() const;
    int getMaxSpielerAnzahl() const;
    int getObjektAnzahl() const;
    int getTeamNummer( int sNum ) const;
};

#endif